3.1. The deploywebstart command-line tool
Prev | 3. Deploying XXE using Java™ Web Start | Next

### 3.1. The deploywebstart command-line tool

Usage: `deploywebstart` `?options?`

Basic options are:

-codebase `url`

  Base URL for all relative URLs in `xxe.jnlp`.

  Default: none when XXE is deployed as an applet (because in such case, specifying a codebase is not strictly needed); `http://`machine name on which deploywebstart was run`/xxe` when XXE is deployed using Java™ Web Start.

-keystore `url`

  Keystore location.

  Default: ``XXE_install_dir`/webstart/testkeystore`

-storetype `type`

  Type of the keystore.

  Default: system dependant, generally `jks`

-storepass `password`

  Password for keystore.

  Default: `teststorepass`

-keypass `password`

  Password for private key.

  Default: `testkeypass`

-alias `alias`

  Alias of keystore entry.

  Default: login name of person running `deploywebstart`.

-index

  Generate a simple `index.html`.

Applet-specific options are:

-applet xxe|viewer|editor1|editor2|`app_class`, -jsapplet xxe|viewer|editor1|editor2|`app_class`

  Deploy application having specified class name as an applet rather than using Java™ Web Start.

  "`xxe`" is a shorthand for "`com.xmlmind.xmleditapp.app.Application`".

  "`viewer`" is a shorthand for "`com.xmlmind.xmleditapp.applet.ViewerApp`".

  "`editor1`" is a shorthand for "`com.xmlmind.xmleditapp.applet.Editor1App`".

  "`editor2`" is a shorthand for "`com.xmlmind.xmleditapp.applet.Editor2App`".

  Option `-jsapplet` is a variant of option `-applet`. Instead of generating an `applet` tag in `index.html`, it includes in `index.html` some smart JavaScript code which, depending on the Web browser host, will dynamically generate the proper `object` or `applet` tag.

-width `pixels_or_percentage`

  Width of the applet.

  Default: 100%.

-height `pixels_or_percentage`

  Height or the applet.

  Default: 600.

Advanced options are:

-selfsigner `dname`

  Specifies a distinguished name (dname) for `testkeystore`. Ignored unless `testkeystore` is used. That is, this option is ignored when a real certificate is used.

  The syntax for distinguished names (dname) is:

      CN=cName,OU=orgUnit,O=org,L=city,S=state,C=countryCode

  where:

  `cName`

    common name of a person, e.g., '`Susan Jones`'.

  `orgUnit`

    department or division name, e.g., '`Purchasing`'.

  `org`

    large organization name, e.g., '`ABCSystems\, Inc.`' (notice the '`\`' used to protect the '`,`').

  `city`

    city name, e.g., '`Palo Alto`'.

  `state`

    state or province name, e.g., '`California`'.

  `countryCode`

    two-letter country code, e.g., '`CH`'.

  Each field must appear in the above order but it is not necessary to specify all fields.

  Default: CN=login name of the person running `deploywebstart`.

  Using this option is absolutely not needed to ``self-sign'' jars. It just allows to create a better looking self-signed certificate.

-online

  Keep configuration files and associated resources (DTD or schema, CSS, XSLT, icons, etc) on the deployment server. This forces the XXE user to work online in order to be able to access the deployment server.

  Default: allow the XXE user to work offline.

-gui `XXE_GUI_spec`

  Specifies which base GUI specification to use. Must be a "`xxe-gui:`" location or a `.xxe_gui` file found in the ``XXE_install_dir`/addon/` directory.

  Default: `xxe-gui:app/Professional.xxe_gui`

  One or more `customize.xxe_gui` files (dynamically discovered by `deploywebstart` in the ``XXE_install_dir`/addon/`) may be used to customize this base GUI specification.

-indexjars

  Index all `.jar` files in order to lazily download them.

-packjars

  Compress all `.jar` files using Pack200 compression.

-quiet

  Turns verbosity off.

The `deploywebstart` command line tool generates deployment files in subdirectory `webstart/` of the XXE installation directory.

For example, if XXE is installed in `/opt/xxe/`, `/opt/xxe/bin/deploywebstart` will recursively scan the installation directory and generates its deployment files in `/opt/xxe/webstart/`.

### Caution

Note that `deploywebstart` only scans the `addon/` subdirectory of the installation directory of XXE. It completely ignores the add-ons found in the `addon/` subdirectory of the user preferences directory.

`Deploywebstart` creates in `webstart/`:

- `xxe.jnlp`.

- `index.html`, if the `-index` option has been used.

- A copy of all the `.jar` files (Java™ code and resources) and the `.dar` files (spell-checker dictionaries) found in ``XXE_install_dir`/addon/` after signing them.

- ``xxe_addon.jar``, a jar file created and signed by `deploywebstart` containing everything found in the ``XXE_install_dir`/addon/` directory (expect `.jar` files and `.dar` files), unless the `-online` option has been used.

By default, `deploywebstart` signs the jars with a self-signed certificate issued by the person running this command-line utility.

Note that because of the default values of these options, if you need to sign the jars with a true certificate, you will have to specify all the four `-storepass`, `-keystore`, `-keypass`, `-alias` options.

Prev | Up | Next
3. Deploying XXE using Java™ Web Start | Home | 3.2. Deploying XXE using Java™ Web Start, a step by step description